#MSN protocol module for SDBA Revolution IM Application Server

use MSN;

#Create a new MSNM instance.
$client = MSN->new();

#To connect - called from sdba.pl
sub imconnect {
	$screenname = shift;
	$password = shift;
	$client->connect("$screenname","$password", 'messenger.hotmail.com', { 
	    Status  => \&sdba_Status,
	    Answer  => \&sdba_Answer,
	    Message => \&sdba_imin, 
	    Join    => \&sdba_Join }
	) or die "Error: Cannot connect to the MSN server!";


}

#To start the loop, whatever it is - called from sdba.pl
#Not used in MSN
sub imcont {
}

#Fill in as you like

sub sdba_Status {
}

sub sdba_Join {
}

sub sdba_Answer {
	my ($self, $username) = @_;

	print "Answer() called with parameters:\n";
	print "   " . join(",", @_), "\n";

	# Send a hello message.
	$$self->sendmsg($SENDINGMSN::reply);
}


#individual handlers
#sub sdba_imin {
	
	#this is what comes in here
	#($aim, $evt, $from, $to) = @_;
	#$args = $evt->args();
	#($victim, $friend, $msg) = @$args;
	
#	on_im(@_);
#}

sub sdba_imin {
    my ($self, $victim, undef, $msg) = @_;
    #on_im($victim, $friend, $msg);
    on_im($victim, undef, $msg, $self);

}




sub RSEND_IM {
	#$vistim, $reply
	($victim, $reply, $screenname, $msg, $innerself) = @_;
	log_im($victim,$msg,$screenname,$reply);

	#Sleep before sending.
	sleep(dosleep(1,3));
	
	#$aim->send_im($victim, "$reply");
	$$innerself->sendmsg("$reply");
}

sub SEND_IM {
	package SENDINGMSN;
	($victim, $reply) = @_;
	#$Common::OUTMSG = "SENDIM is not supported yet for MSN.";
	$main::client->call($victim); 
}



1;