#!/usr/bin/perl -w
#########################################
#                                       #
#        SDBA Revolution v 1.8          #
#                                       #
#########################################

package main;
require "config.im";

$SDBAVersion = "1.85";
$SDBAStartTime = time;
#print $SDBAStartTime;
if (not defined $JabberServer){$JabberServer = '';}
if (not defined $JabberPort){$JabberPort = '';}
if (not defined $JabberResource){$JabberResource = '';}
if (not defined $admin){$admin = '';}
$dmp= "";
$dmp = $screenname.$password.$admin.$imnet.$SDBAStartTime.$SDBAVersion;

#Use the module File-Basename so that the script can be called from anywhere.
use File::Basename;
chdir(dirname($0));

#Seed the random number generator.
srand time;

#Print two blank lines to the DOS window.
print "\n\n";

#Check to make sure the required directories exist.
if (-e "commands" ne 1 
 || -e "bin" ne 1 
 || -e "logs" ne 1) {

	print "You seem to be missing the required directories: "
	. " please make sure everything unzipped correctly.";
	exit;

}

#Use protocol declared in config.im.
require "bin/protocols/$imnet.pl" 
	or die "Looks like you should choose another protocol in config.im";

#Gain usage of all the files in the Handlers, Commands, and Extras folders.
@dirs = ("commands","bin");
foreach $dir (@dirs) {
  opendir(DIR, "./$dir");
  foreach $file (sort(grep(!/^\./, readdir(DIR)))) {
    if (!(-d "$dir/$file")){
      #print "Including $file..";
      require "$dir/$file";
      #print " OK!\n";
    }
  }
  closedir(DIR);
}

#Try to connect to the AIM server.
imconnect($screenname, $password, $JabberServer, $JabberPort, $JabberResource);


#Start an infinite sequence of 'do_one_loop's and print the confirmation message.
print "\nSDBA Revolution IM Application Server loaded successfully!\n\n";

imcont();