################################
# Borrowed with few changes from WIRED BOTS
#
# on_config();
#
#  desc: This sub is called when the bot is being loaded.
#	 It grabs the default AIM vars,
#	 Then sets the bots profile,
#	 Then sends the config.
#  recv: AIM's default vars.
# sends: Nothing.
################################
sub on_config {
   my ($self, $evt, $from, $to) = @_;
	
   my $str = shift @{$evt->args()};
   $self->set_config_str($str, 1);

#Set up the bot's profile.
#Split it up so we can avoid the 80 character limit.

	$self->set_info("SDBA Revolution Instant Messaging Application Server v 1.0 - "
	             . "$ServerName");

#Send the config.
$self->send_config();

}
1;
