#AIM protocol module for SDBA Revolution IM Application Server

use Net::AIM;

#Create a new Net-AIM instance.
$aim = new Net::AIM;

#To connect - called from sdba.pl
sub imconnect {
	$screenname = shift;
	$password = shift;
	$aim->newconn( Screenname => $screenname,
		       Password   => $password,
		       AuthServer => 'login.icq.com',
	 	       AuthPort => 5150)
			or die "Error: Cannot connect to the AIM server!";

	#Get a reference to the Net-AIM-Connection module.
	$conn = $aim->getconn();

	#Set up the handlers for commands issued by the server.
	$conn->set_handler('im_in', \&sdba_imin);
	$conn->set_handler('error', \&aim_error);
	$conn->set_handler('eviled', \&aim_evil);
	$conn->set_handler('config', \&sdba_config);

}

#To start the loop, whatever it is - called from sdba.pl
sub imcont {
	$aim->start;
}

#individual handlers
sub sdba_imin {
	
	#this is what comes in here
	#($aim, $evt, $from, $to) = @_;
	#$args = $evt->args();
	#($victim, $friend, $msg) = @$args;
	($aim, $evt, $from, $to) = @_;
	$args = $evt->args();
	($victim, $friend, $msg) = @$args;
	
	on_im($victim, $friend, $msg);
}

sub sdba_config {
	on_config(@_);
}

sub RSEND_IM {
	#$vistim, $reply
	($victim, $reply, $screenname, $msg) = @_;
	log_im($victim,$msg,$screenname,$reply);

	SEND_IM ($victim, $reply);
}

sub SEND_IM {
	#$vistim, $reply
	($victim, $reply) = @_;
	#Sleep before sending.
	#Queue em up
	#Max for AIM is 1024, so take a little off for the page #
	my $maxlen = $MaxMessageSize;
	my $lstr = "";	#just for slicing the string
	my @q;		#queue array
	my $i = 1;
	while (length($reply) > $maxlen){
		$lstr = substr($reply,0,$maxlen);
		$reply = substr($reply,$maxlen-length($reply));
		push (@q, $lstr);
	}
	$h = $#q;
	$h = $h+2;  #number of total messages this is split into
	foreach $reply (@q){
		#header for extra-long messages
		$reply = "$i of $h\n".$reply;
		sleep(dosleep(1,3));
		$aim->send_im($victim, "$reply");
		$i++;
	}

	#sleep to avoid getting kicked for flooding
	#rest or message, for a normal message goes straight to this
	sleep(dosleep(1,3));
	$aim->send_im($victim, "$reply");
}

1;