################################
# about.pl
#
# invoke with /about
#
################################

sub about {
	$Common::OUTMSG = "\n$ServerName\n";
	$Common::OUTMSG .= "SDBA Revolution IM Server\nVersion: $main::SDBAVersion"
	."\nProtocol: $main::imnet"
	."\nUptime: ";
	my $diff = time - $SDBAStartTime;
	my $dDiff = int($diff / 86400); 
	my $hDiff = int(($diff - $dDiff*86400) / 3600);
	my $mDiff = int(($diff-$dDiff*86400-$hDiff*3600) / 60);
	my $sDiff = sprintf("%02d", $diff - $dDiff*86400 - $hDiff*3600 - 60 * $mDiff);
	$Common::OUTMSG .=  "$dDiff days, $hDiff h, $mDiff m, $sDiff s\n";

}
1;
